
/*     Sistemas Operativos II     */
/*     prac9.c     */

#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>
#include <stdlib.h>
#include <stdio.h>

int mi_system(char *cmdstring);

void pr_exit(int estado);


int main()
{
  int status;

  if ((status = mi_system("date")) < 0) perror("system() error");
  pr_exit(status);

  if ((status = mi_system("nosuchcommand")) < 0) perror("system() error");
  pr_exit(status);

  if ((status = mi_system("who; exit 44")) < 0) perror("system() error");
  pr_exit(status);

  exit(0);
}

int mi_system(char *cmdstring) {
  int pid;
  int status;
  int aux;
  
  
  pid=fork();
  if (pid==-1) {     
    return -1;
  } else {
    if (pid==0) {
      return execlp("bash", "bash", "-c", cmdstring, NULL);
    } else {
      wait(&status);
      return status;
    }
  }
}  

void pr_exit(int estado)
{
  if (WIFEXITED(estado)) printf("Terminacion normal, exit status = %d\n", WEXITSTATUS(estado));
  else if (WIFSIGNALED(estado))
  { 
    printf("Terminacion anormal, numero de signal = %d ", WTERMSIG(estado));
    if (WCOREDUMP(estado)) printf("(se genero fichero core)\n");
    else printf(" \n");
  }
  else if (WIFSTOPPED(estado)) printf("Hijo detenido, numero de signal = %d\n", WSTOPSIG(estado));
}

