#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>


union semun {
     int              val;    /* Value for SETVAL */
     struct semid_ds *buf;    /* Buffer for IPC_STAT, IPC_SET */
     unsigned short  *array;  /* Array for GETALL, SETALL */
     struct seminfo  *__buf;  /* Buffer for IPC_INFO
     (Linux-specific) */
};

void op_signal(int sem, int n)
{
  struct sembuf sop;/* Construir un elemento de vector de operaciones */
  sop.sem_num = n;
  sop.sem_op = 1;/* Operación signal o liberar una copia recurso */
  sop.sem_flg = 0;
  semop(sem, &sop, 1);/* Operación signal propiamente dicha */
}

void op_wait(int sem, int n)
{
  struct sembuf sop;  /* Construir un elemento de vector de operaciones */
  sop.sem_num = n;
  sop.sem_op = -1;/* Operación wait u obtención una copia recurso */
  sop.sem_flg = 0;
  semop(sem, &sop, 1);/* Operación wait propiamente dicha */
}

int main (int argc, char *argv[]) {
  int semid;
  int num_escritor;
  int time;
  int key;
  
  num_escritor=atoi(argv[1]);
  key=atoi(argv[2]);
  time=atoi(argv[3]);
  
  semid=semget(key, 3, 0);
  while (1) {
    sleep(time);
    op_wait(semid, 1);
    printf("\n\nE%d ESTOY ESCRIBIENDO EN LA BASE DE DATOS ", num_escritor); fflush(stdout);
    sleep(time);
    printf("\n\nE%d HE TERMINADO DE ESCRIBIR", num_escritor); fflush(stdout);
    op_signal(semid, 1);    
  }
}