#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>


union semun {
     int              val;    /* Value for SETVAL */
     struct semid_ds *buf;    /* Buffer for IPC_STAT, IPC_SET */
     unsigned short  *array;  /* Array for GETALL, SETALL */
     struct seminfo  *__buf;  /* Buffer for IPC_INFO
     (Linux-specific) */
} arg0;

struct semi_ds
{
  struct ipc_perm sem_perm;
  struct sem *sem_base;
  ushort sem_nsems;
  time_t sem_otime;
  time_t sem_ctime;
};

struct sem
{
  ushort semval;
  pid_t sempid;
  ushort semncnt;
  ushort semzcnt;
};

void op_signal(int sem, int n)
{
  struct sembuf sop;/* Construir un elemento de vector de operaciones */
  sop.sem_num = n;
  sop.sem_op = 1;/* Operación signal o liberar una copia recurso */
  sop.sem_flg = 0;
  semop(sem, &sop, 1);/* Operación signal propiamente dicha */
}


void op_wait(int sem, int n)
{
  struct sembuf sop;  /* Construir un elemento de vector de operaciones */
  sop.sem_num = n;
  sop.sem_op = -1;/* Operación wait u obtención una copia recurso */
  sop.sem_flg = 0;
  semop(sem, &sop, 1);/* Operación wait propiamente dicha */
}

int main (int argc, char *argv[]) {
  int semid;
  int num_lector;
  int time;
  int key;
  
  num_lector=atoi(argv[1]);
  key=atoi(argv[2]);
  time=atoi(argv[3]);
  
  
  semid=semget(key, 3, 0);
  while (1) {
    
    op_wait(semid, 0);
    arg0.val=semctl(semid, 2, GETVAL);
    arg0.val++;
    semctl(semid, 2, SETVAL, arg0);//readcount=readcount+1;
    if (arg0.val=1) {
      op_wait(semid, 1);
    }
    op_signal(semid, 1);
    printf("\n\nL%d ESTOY LEYENDO EN LA BASE DE DATOS ", num_lector);fflush(stdout);
    sleep(time);
    printf("\n\nL%d HE TERMINADO DE LEER", num_lector);fflush(stdout);
    op_wait(semid, 0);
    arg0.val=semctl(semid, 2, GETVAL);
    arg0.val--;
    semctl(semid, 2, SETVAL, arg0);//readcount=readcount-1;
    if (arg0.val=0) {
      op_signal(semid, 1);
    }
    op_signal(semid, 0);
  }
}