
/*     Sistemas Operativos II     */
/*     prac10.c     */

#include <unistd.h>
#include <sys/times.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>

void do_cmd(char *cmd);

void pr_times(clock_t real, struct tms *tmsstar, struct tms *tmsend);

void pr_exit(int estado);


int main(int argc, char *argv[])
{
  int i;

  for (i = 1; i < argc; i++) do_cmd(argv[i]);

  exit(0);
}

void do_cmd(char *cmd)
{
  struct tms tmsstart, tmsend;
  clock_t start, end;
  int status;

  fprintf(stderr, "\n command: %s \n", cmd);

  if ((start = times (&tmsstart)) == -1) perror("times error");

  if ((status = system(cmd)) < 0) perror("system() error");

  if ((end = times(&tmsend)) == -1) perror("times error");

  pr_times(end - start, &tmsstart, &tmsend);

  pr_exit(status);
}

void pr_times(clock_t real, struct tms *tmsstart, struct tms *tmsend)
{
  static long clktck = 0;

  if (clktck == 0)
    if ((clktck = sysconf(_SC_CLK_TCK)) < 0) perror("sysconf error");

  fprintf(stderr, " real: %7.2f \n", real / (double) clktck);

  fprintf(stderr, " user: %7.2f \n", (tmsend->tms_utime - tmsstart->tms_utime) / (double) clktck);

  fprintf(stderr, " sys: %7.2f \n", (tmsend->tms_stime - tmsstart->tms_stime) / (double) clktck);

  fprintf(stderr, " child user: %7.2f \n", (tmsend->tms_cutime - tmsstart->tms_cutime) / (double) clktck);

  fprintf(stderr, " child sys: %7.2f \n", (tmsend->tms_cstime - tmsstart->tms_cstime) / (double) clktck);
}

void pr_exit(int estado)
{
  if (WIFEXITED(estado)) printf("Terminacion normal, exit status = %d\n", WEXITSTATUS(estado));
  else if (WIFSIGNALED(estado))
  { 
    printf("Terminacion anormal, numero de signal = %d ", WTERMSIG(estado));
    if (WCOREDUMP(estado)) printf("(se genero fichero core)\n");
    else printf(" \n");
  }
  else if (WIFSTOPPED(estado)) printf("Hijo detenido, numero de signal = %d\n", WSTOPSIG(estado));
}

