Problema2.c
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

//NOTA: Para unix la estructura cambia
union semun{
  int val; /*Para SETVAL*/
  struct semid_ds *buf; /*buffer para IPC_STAT y IPC_SET*/
  unsigned short int *array; /*array para GETALL, SETALL*/
  struct seminfo *_buf; /*buffer para IPC_INFO*/
}arg; 

int main(){

 int id_semaforo; //manejador del vector de semaforos
 int key = 5; //Clave numerica que identifica al vector de semaforos
 int cant_sem = 5; // Numero de semaforos a crear
 int i,valor;

/*
la funcion semget, crea un vector se semaforos.
1 argumento: Clave numerica que identifica al vector de semaforos
2 argumento: Numero de semaforos que se quieren crear
3 argumento: Permisos del conjunto de semaforos
*/

 printf("\nParte A: Creo un vector con %d semaforos\n", cant_sem);
 fflush(stdout);

if((id_semaforo = semget(key, cant_sem, IPC_CREAT|0666))!=-1){
  printf("El identificador del vector de semaforos es %d\n\n", id_semaforo);

  printf("Parte B: Inicializo cada semaforo\n");
  i = 0;

/*
La funcion semctl, inicializa los semaforos 
1 argumento: Es el numero del vector que contiene los semaforos
2 argumento: Es el indice del semaforo, dentro de vector.
3 argumento: Comando a ejecutar.
4 argumeto: Puede estar o no, si esta, ira acorde con 
el tercer argumento.
*/
  for(i = 0; i < cant_sem; i++){
    printf("Inicializo el semaforo n %d\n", i);
    arg.val = 1;
    semctl(id_semaforo, i, SETVAL, arg);
  }
  
  printf("\n");
  fflush(stdout);
  
  printf("Parte C: Enseo los valores de cada semaforo\n");
  
  
  
  for(i = 0; i < cant_sem; i++){
    printf("Muestro el valor del semaforo n %d, su valor es: \n", i);
    valor = semctl(id_semaforo, i, GETVAL);
    printf("%d\n", valor);
  }
 
 printf("Preparando el resto de la ejecucion...\n\n");
 
 }else{
  printf("ERROR: No se ha podido crear el semaforo\n");
  exit(1);
  
  
 }

}

Filosofos.c
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <errno.h>

union semun{
  int val; /*Para SETVAL*/
  struct semid_ds *buf; /*buffer para IPC_STAT y IPC_SET*/
  unsigned short int *array; /*array para GETALL, SETALL*/
  struct seminfo *_buf; /*buffer para IPC_INFO*/
}arg;

void op_signal(int sem, int n);
void op_wait(int sem, int n);

int main(int argc, char *argv[]){

int i, valor_aux, pos_filosofo, tiempo_pensamiento;

int id_semaforo; // Variable donde recogemos el identificador del semaforo
int key = 5; // Clave que identifica al vector de los semaforos.
int cant_sem = 5; // Numero de semaforos que tiene el vector de semaforos.
int valor;				  // En este caso son los palillos chinos.

pos_filosofo = (atoi(argv[1]));
tiempo_pensamiento = (atoi(argv[2]));

if ((id_semaforo = semget(key, cant_sem, 0)) != -1){

	while(1){
		printf("El filosofo %d esta PENSANDO\n\n", pos_filosofo);
		fflush(stdout);
		sleep(tiempo_pensamiento);
		
		//El sleep, se introduce para simular, que el filosofo esta pensando, se intenta
		//que el tiempo de pensamiento para todos los filosofos no sea el mismo
		//Asi es mas divertido :) 
		
		//Ejecucion asimetrica
		if(pos_filosofo % 2 == 0){//La posicion es PAR	

		 printf("El filosofo %d esta EMPEZANDO A COMER\n\n", pos_filosofo);
		 
		  op_wait(id_semaforo, pos_filosofo);
		  op_wait(id_semaforo, ((pos_filosofo + 1) % 5));
		
		    //Sleep para que lo filosofos coman.
		    sleep(tiempo_pensamiento);
		
		
		  printf("El filosofo %d esta TERMINANDO DE COMER\n\n", pos_filosofo);
		  fflush(stdout);
		  
		}else{//Si es impar
		
		//printf("\n pos: %d | pos + 1: %d",pos_filosofo, (pos_filosofo + 1)%5 );
		// fflush(stdout);
		
		  op_wait(id_semaforo, ((pos_filosofo + 1) % 5));
		  op_wait(id_semaforo, pos_filosofo);
		  
		  printf("El filosofo %d esta EMPEZANDO A COMER\n\n", pos_filosofo);
			fflush(stdout);
		
		 for(i = 0; i < 5; i++){
    valor = semctl(id_semaforo, i, GETVAL);
  }
		    //Sleep para que lo filosofos coman.
		    sleep(tiempo_pensamiento);
		
		  printf("El filosofo  %d esta TERMINANDO DE COMER\n\n", pos_filosofo);
		  fflush(stdout);
		}
		
		op_signal(id_semaforo, pos_filosofo);
		op_signal(id_semaforo, ((pos_filosofo + 1) % 5));
	}
}else{
	printf("La llamada semget ha fallado su valor es -1\n");
}

	exit(0);
}


void op_signal(int sem, int n){
	
	int valor_semop_signal = 0;
	
	struct sembuf sop; /*Construir un elemento de vector de operaciones*/
	
	sop.sem_num = n;
	sop.sem_op = 1; /*Operacion signal o liberar una copia recurso*/
	sop.sem_flg = 0;
	
	valor_semop_signal = semop(sem, &sop, 1); /*Operacion signal propiamente dicha*/
	
	if(valor_semop_signal == -1){
		printf("ERROR:El valor de semop es -1 en signal\n");
	}//else{
		//printf("El valor de semop es %d\n", valor_semop_signal);
	//}
}

void op_wait(int sem, int n){
	
	int valor_semop_wait = 0;	
	
	struct sembuf sop; /*Construir un elemento de vectos de operaciones*/
	
	sop.sem_num = n;
	sop.sem_op = -1; /*Operacion wait u obtencion una copia recurso*/
	sop.sem_flg = 0;
	
	valor_semop_wait = semop(sem, &sop, 1); /*Operacion wait propiamente dicha*/
	
	if(valor_semop_wait == -1){
		printf("ERROR: El valor de semop en wait es -1\n");
	}//else{
		//printf("El valor de semop es %d\n", valor_semop_wait);
	//}
}

Prueba_filosofos.sh
#!/bin/bash

./problema2
./filosofos 0 1 &
./filosofos 1 1 &
./filosofos 2 1 &
./filosofos 3 1 &
./filosofos 4 1 &

4 FILOSOFOS SE SIENTAN A LA MESA Y UNO SE QUEDA FUERA
Creasem.c
/*
 * Programa que crea un vector de semaforos
 * para el problema de los filsofos.
 * 
 */

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <stdio.h>


int main() {
    
    
    union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
    } arg;
    
    int semid;
    int key = 125;
    int numsem = 6;
    int tenedor;
    ushort valtenedor[6] = {1,1,1,1,1,4};
    
    
    //borramos semaforos preexistentes
    if ((semid = semget(key, numsem, 0)) != -1) {
	semctl(semid, 0, IPC_RMID);
    }
    
    //creamos vector de semaforos
    if ((semid = semget(key, numsem, IPC_CREAT | 0600)) != -1) {
  
	//inicializamos semaforo objetos
	/*arg.val = 1;
	for (tenedor = 0; tenedor < 5; tenedor++) {
	    semctl(semid, tenedor, SETVAL, arg);
	} */
	
	arg.array = valtenedor;
	semctl(semid, 0, SETALL, arg);

    }
    
    //Comprobamos que las inicializaciones son correctas
//     for (tenedor = 0; tenedor < 6; tenedor++) {
// 	printf("TENEDOR %d = %d \n", tenedor, semctl(semid, tenedor, GETVAL));
//     } 
//     
    
   /* semctl(semid, 0, GETALL, arg);
    
    for (tenedor = 0; tenedor < 5; tenedor++) {
	printf("TENEDOR %d = %d \n", tenedor, arg.array[tenedor]);
    }*/
    
    
    return(0);
    
}

Filosofo.c
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <stdio.h>



void op_wait(int sem, int n);

void op_signal(int sem, int n);

void comer(int n, int numfilosofo);

void pensar(int n, int numfilosofo);


int main(int argc, char* argv[]) {
    
    int semid;
    int key = 125;
    int numsem = 6;
    
    int tiempo;
    int numfilosofo;
    
    
    tiempo = atoi(argv[2]);
    numfilosofo = atoi(argv[1]);
    semid = semget(key, numsem, 0);
    
    
    while(1) {
	pensar(tiempo, numfilosofo);      

	op_wait(semid,5); 	

	printf("El filosofo %d se sienta en la mesa\n", numfilosofo); 
	fflush(stdout);
	op_wait(semid, numfilosofo);      
	op_wait(semid, (numfilosofo + 1) % 5 );         
    
	comer(tiempo, numfilosofo);
	
	op_signal(semid, numfilosofo);
	op_signal(semid, (numfilosofo + 1) % 5 );
	printf("El filosofo %d se levanta de la mesa\n", numfilosofo);  
	fflush(stdout);
	op_signal(semid, 5);
    }
}


void op_wait(int sem, int n) {
    struct sembuf sop;		/* Construir un elemento de vector de operaciones */
    sop.sem_num = n;
    sop.sem_op = -1;		/* Operacin wait u obtencin una copia recurso */
    sop.sem_flg = 0;
    semop(sem, &sop, 1);	/* Operacin wait propiamente dicha */
}

void op_signal(int sem, int n) {
    struct sembuf sop;		/* Construir un elemento de vector de operaciones */
    sop.sem_num = n;
    sop.sem_op = 1;		/* Operacin signal o liberar una copia recurso */
    sop.sem_flg = 0;
    semop(sem, &sop, 1);	/* Operacin signal propiamente dicha */
}

void comer(int n, int numfilosofo) {
    printf("\nFilosofo %d empezando a comer...\n", numfilosofo); 
    fflush(stdout);
    sleep(n);
    printf("\nFilosofo %d terminando de comer...", numfilosofo); 
    fflush(stdout);
}

void pensar(int n, int numfilosofo) {
    printf("Filosofo %d pensando...\n", numfilosofo);
    fflush(stdout);
    sleep(n);
}




LECTOR ESCRITOR VERSIN 2.
Lec_esc_inicializar.c
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/sem.h>
#include <sys/ipc.h>
#include <sys/types.h>

//#define key_t key;

int crear_sem(int key, int num_sem);
int inicializar_sem(int manejador, int componente, int valor_sem);
int valor_sem (int semid, int pos);
void op_wait(int semid, int pos);
void op_signal(int semid, int pos);



int main(int argc,char *argv[]){
	int semid, num_sem, clave;
	
	if (argc != 3) {
		printf("Error en el numero de argumentos, [clave, num_sem] \n");
		exit(0);
		
	}else{
		
		//obtengo los valores pasados como argumento por consola
		clave = atoi(argv[1]);  	//clave 578557	
		num_sem = atoi(argv[2]);
		int num_lectores = 3;
		
		semid = crear_sem(clave, num_sem);
		inicializar_sem(semid, 0, 1);	//mutex=1
		inicializar_sem(semid, 1, num_lectores);	//lectores = Num_lectores
		
		printf("Se ha creado el semaforo con identificador %d para el problema lector-escritor correctamente \n", semid);
		fflush(stdout);
	}
}


int crear_sem(int key, int num_sem){
	int manejador= 0 ;
	
	manejador = semget(key, num_sem, IPC_CREAT | 0600);  //semget devuelve el manejador que identifica al semaforo
	
		if (manejador >=0 ){  //si se ha creado correctamente el identif del sem sera 0 o mayor de cero
		printf("Se ha creado correctamente un vector de semaforos con %d componentes \n", num_sem);
		printf("Ha sido creado correctamente el semaforo con clave= %d\n", key);
		fflush(stdout);
		return(manejador);	
	}else{
		printf("Error al crear el semaforo con clave %d\n ", key);
		exit(1);
	}
}

int inicializar_sem(int manejador, int componente, int valor_sem){
	union semun{
			int val;  //para SETVAL
			struct semid_ds *buf; //IPC_STAT y IPC_SET
			unsigned short int *array; //GETALL y SETALL
			struct seminfo *__buf;
	} semctl_arg;
	semctl_arg.val = valor_sem;

	if(semctl(manejador, componente, SETVAL, semctl_arg) == 0) {
		printf("Se ha inicializado correctamente a %d la componente %d del semaforo %d\n", valor_sem, componente, manejador);
		fflush(stdout);
		return(0);
	}else{
		printf("Error al inicializar la componente %d del semaforo %d\n", componente, manejador);
		fflush(stdout);
		return(-1);
	}
}

int valor_sem (int semid, int pos){
		int val_sem; 
		
	   union semun {
	   int val;                    /* valor para SETVAL */
	   struct semid_ds *buf;       /* buffer para IPC_STAT, IPC_SET */
	   unsigned short int *array;  /* array para GETALL, SETALL */
	   struct seminfo *__buf;      /* buffer para IPC_INFO */
	} semctl_arg;

		val_sem= semctl(semid, pos, GETVAL, semctl_arg);
		if (val_sem <0) {
			fflush(stdout);
			exit(0);
		}else{
			return (val_sem);
		}
	}

Lector.c
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/sem.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <unistd.h>

void op_wait(int semid, int pos);
void op_signal(int semid, int pos);
int valor_sem (int semid, int pos);


union semun {
	   int val;                    /* valor para SETVAL */
	   struct semid_ds *buf;       /* buffer para IPC_STAT, IPC_SET */
	   unsigned short int *array;  /* array para GETALL, SETALL */
	   struct seminfo *__buf;      /* buffer para IPC_INFO */
	} semctl_arg;

int main (int argc, char *argv[]) {
	int clave, num_lector, tiempo, semid;
	
	
	if (argc != 4) {
		printf("Error en el lector");
		exit(0);
		
	}else{
		
	/* mutex=0
	 * lectores=1
	 */	
	 	
	num_lector =atoi(argv[1]);
	clave =atoi(argv[2]);
	tiempo =atoi(argv[3]);
	int iteraciones = 5;
	int j= 0;
	
	semid = semget(clave, 2, 0);  //accedo al semaforo
	
	 while (j < iteraciones) {
		 printf("LECTOR  %d: INTENTO \n",num_lector);
		 fflush(stdout);
		 
		 op_wait(semid, 0); //wait(mutex)
		 op_wait(semid, 1); //wait(lectores)
		 op_signal(semid, 0); //signal(mutex)
		 
		printf("LECTOR  %d: LEYENDO \n",num_lector); fflush(stdout);
		sleep(tiempo);
		op_signal(semid, 1); //signal(lectores)
		printf("LECTOR  %d: FIN \n",num_lector);
		fflush(stdout);
		j++;
	}	
  }
}


int valor_sem (int semid, int pos){
		int val_sem; 
		
	   union semun {
	   int val;                    /* valor para SETVAL */
	   struct semid_ds *buf;       /* buffer para IPC_STAT, IPC_SET */
	   unsigned short int *array;  /* array para GETALL, SETALL */
	   struct seminfo *__buf;      /* buffer para IPC_INFO */
	} semctl_arg;

		//int posi;
		val_sem= semctl(semid, pos, GETVAL, semctl_arg);
		if (val_sem <0) {
			exit(0);
		}else{
			return (val_sem);
		}
	}
		
void op_wait(int semid, int pos){
		struct sembuf sop;  //estructura menejo de operaciones sobre el semaforo	
			/*Inicializar valores*/
			sop.sem_num= pos;
			sop.sem_op= -1;
			sop.sem_flg= 0;
			/* Ejecucin de una operacin Down sobre sem_id: */
			semop(semid,&sop,1);
	}
	
void op_signal(int semid, int pos){
	struct sembuf sop;  //estructura menejo de operaciones sobre el semaforo	
	/*Inicializar valores*/
	sop.sem_num= pos;
	sop.sem_op= 1;
	sop.sem_flg= 0;
	/* Ejecucin de una operacin Up sobre sem_id: */
	semop(semid,&sop,1);
}	
	

Escritor.c
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/sem.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <unistd.h>

void op_wait(int semid, int pos);
void op_signal(int semid, int pos);
int valor_sem (int semid, int pos);

int main (int argc, char *argv[]) {
	int clave, num_escritor, tiempo, semid, i;
	
	
	if (argc != 4) {
		printf("Error en el escritor");
		exit(0);
		
	}else{
		
	num_escritor =atoi(argv[1]);
	clave =atoi(argv[2]);
	tiempo =atoi(argv[3]);
	int iteraciones = 5;
	int j=0;
	
	semid = semget(clave, 2, 0);  //accedo al semaforo
	
	
	
	 while (j < iteraciones) {
		 printf("ESCRITOR  %d: INTENTO\n",num_escritor);
		 fflush(stdout);
		 op_wait(semid, 0); //wait(mutex)
		 
		 for (i=1; i<=3; i++) {
			op_wait(semid, 1); //wait(lectores)
		}
		printf("ESCRITOR  %d: ESCRIBIENDO\n",num_escritor); fflush(stdout);
		sleep(tiempo);		
		for (i=1; i<=3; i++) {
			op_signal(semid, 1); //signal(lectores)
		}
		
		op_signal(semid, 0); //signal(mutex)
		printf("ESCRITOR  %d: FIN\n",num_escritor); fflush(stdout);
		j++;
		}
	}
}
		 
int valor_sem (int semid, int pos){
		int val_sem; 
		
	   union semun {
	   int val;                    /* valor para SETVAL */
	   struct semid_ds *buf;       /* buffer para IPC_STAT, IPC_SET */
	   unsigned short int *array;  /* array para GETALL, SETALL */
	   struct seminfo *__buf;      /* buffer para IPC_INFO */
	} semctl_arg;

		val_sem= semctl(semid, pos, GETVAL, semctl_arg);
		if (val_sem <0) {
			fflush(stdout);
			exit(0);
		}else{
			return (val_sem);
		}
	}		
void op_wait(int semid, int pos){
		struct sembuf sop;  //estructura menejo de operaciones sobre el semaforo	
			/*Inicializar valores*/
			sop.sem_num= pos;
			sop.sem_op= -1;
			sop.sem_flg= 0;
			/* Ejecucin de una operacin Down sobre sem_id: */
			semop(semid,&sop,1);
	}
	
void op_signal(int semid, int pos){
	struct sembuf sop;  //estructura menejo de operaciones sobre el semaforo	
	/*Inicializar valores*/
	sop.sem_num= pos;
	sop.sem_op= 1;
	sop.sem_flg= 0;
	/* Ejecucin de una operacin Up sobre sem_id: */
	semop(semid,&sop,1);
}	
	

Lanzar_lect_escritor.sh
#!/bin/sh

gcc -O2 -o lec_esc_inicializar lec_esc_inicializar.c
gcc -O2 -o lector lector.c
gcc -O2 -o escritor escritor.c

# inicializo un semaforo con clave 578557 y componenetes
./lec_esc_inicializar 578557 2

./escritor 1 578557 2 & #num_lector, clave, tiempo
./escritor 2 578557 2 &
./escritor 3 578557 2 &
./lector 1 578557 2 &
./lector 2 578557 2 &
./lector 3 578557 2 &










PRODUCTOR CONSUMIDOR
Inicioprodcons.c
#include <sys/types.h>
#include <string.h>

#define MUTEX 0
#define HUECOS 1
#define OBJETOS 2
#define MAX_BUFFER 10
#define VALORINICIAL 5

union semun{
  int val;
  struct semid_ds *buf;
  ushort *array;
}arg;

int main(int argc, char *argv[]){

	//union semun arg;
	int semid, i , control;
	
	int key = atoi(argv[1]);
	int nsems = atoi(argv[2]);

	//semid = semget(key, nsems, IPC_CREAT|0600);
	
	if((semid = semget(key, nsems, MUTEX)) != -1) 	// Obtengo el manejador en modo uso (0)
		semctl(semid, MUTEX, IPC_RMID);		// Borro el anterior conjunto de semaforos

	if((semid = semget(key, nsems, IPC_CREAT|0600)) != -1){
		

		arg.val = 1;		//Inicializo MUTEX a 1
		semctl(semid,MUTEX,SETVAL,arg);
		arg.val = 5;		//Inicializo HUECOS a 5
		semctl(semid, HUECOS, SETVAL, arg);	
		arg.val= 5;			//Inicializo OBJETOS a 5
		semctl(semid,OBJETOS,SETVAL,arg);
	}
	
	control = semctl(semid,MUTEX,SETVAL,arg);
    printf("Control del semaforo mutex:%d\n", control);
	fflush(stdout);
	
	control = semctl(semid,HUECOS,GETVAL);
	printf("VALOR del semaforo huecos:%d\n", control);
	fflush(stdout);
	
	control = semctl(semid,OBJETOS,GETVAL);
	printf("VALOR del semaforo objetos:%d\n", control);
	fflush(stdout);

	printf("\nFIN Inicializacion\n");fflush(stdout);
	//exit(0);

}

Productor.c
#include <sys/types.h>

#define MUTEX 0
#define HUECOS 1
#define OBJETOS 2

#define KEY 123
#define MAX_BUFFER 10

union semun{
  int val;
  struct semid_ds *buf;
  ushort *array;
} arg;

void op_wait(int sem, int n);
void op_signal(int sem, int n);

int main(int argc, char *argv[]){

//	union semun arg;
    int semid;

	int nsems = 3;
	int numprod, key, delay;
	int huecos, objetos;

	key = atoi(argv[1]);
	numprod = atoi(argv[2]);
	delay = atoi(argv[3]);

  	semid = semget(key, nsems, MUTEX);

	if(semid == -1){
	  printf("\nHa ocurrido un error al acceder al semaforo.");fflush(stdout);	
	}
 
	printf("\nProductor %d manejador del semaforo:%d\n",numprod, semid);fflush(stdout);
	
	while (1){
	
		//printf("\n");fflush(stdout);
		sleep(delay);
		
		if (semctl(semid,HUECOS,GETVAL,arg)>0) {
		
			op_wait(semid, HUECOS);		//wait(huecos)
			huecos = semctl(semid,HUECOS,GETVAL,arg);		//Se obtienen los huecos
	
			op_wait(semid, MUTEX);		//wait(mutex)
			op_signal(semid, MUTEX);	//signal(mutex)
   
			op_signal(semid, OBJETOS);	//signal(objetos)
			objetos = semctl(semid,OBJETOS,GETVAL,arg);		//Se obtiene los objetos

			printf("\nProductor %d aade un objeto, Objetos:%d, Huecos:%d\n",numprod, objetos,huecos);
			fflush(stdout);
		}else {
			printf("Productor %d, NO HAY HUECOS, NO PUEDO PRODUCIR\n",numprod);
			fflush(stdout);
		}
	}
}

void op_wait(int sem, int n){
  struct sembuf sop;

  sop.sem_num = n;
  sop.sem_op = -1;
  sop.sem_flg = 0;
  semop(sem, &sop,1);
}

void op_signal(int sem, int n){
  struct sembuf sop;

  sop.sem_num = n;
  sop.sem_op = 1;
  sop.sem_flg = 0;
  semop(sem, &sop,1);
}

Consumidor.c
#include <sys/types.h>
#include <stdio.h>

#define MUTEX 0
#define HUECOS 1
#define OBJETOS 2

#define MAX_BUFFER 10


union semun {
	int              val;    // Value for SETVAL
	struct semid_ds *buf;    // Buffer for IPC_STAT, IPC_SET
	unsigned short  *array;  // Array for GETALL, SETALL
	struct seminfo  *__buf;  // Buffer for IPC_INFO (Linux-specific)
}arg;


void op_signal(int sem, int n);
void op_wait(int sem, int n);

int main(int argc, char *argv[]){

//	union semun arg;

	int semid;
	int nsems = 3;
	int numcons, key, delay;
	
	int objetos, huecos;

	key = atoi(argv[1]);
	numcons = atoi(argv[2]);
	delay = atoi(argv[3]);

	semid = semget(key, nsems, MUTEX);

	if(semid == -1){
		printf("\nHa ocurrido un error al acceder al semaforo.");
		fflush(stdout);	
	}
 
	printf("Consumidor %d manejador del semaforo:%d\n", numcons, semid);fflush(stdout);

	
	while (1){

		sleep(delay);
		
		if (semctl(semid,OBJETOS,GETVAL,arg)>0) {
			
		
		op_wait(semid, OBJETOS);    
		objetos = semctl(semid,OBJETOS,GETVAL,arg);		//Obtiene el valor del semaforo 2

		op_wait(semid, MUTEX);
			
		op_signal(semid, MUTEX);	//signal(mutex)
		op_signal(semid, HUECOS);	//signal(huecos)
		huecos = semctl(semid,HUECOS,GETVAL,arg);		//Obtiene el valor del semaforo 1
			printf("Consumidor %d, quita un objeto. Objetos:%d, Huecos:%d\n",numcons, objetos, huecos);
			fflush(stdout);
		}else {
			printf("Consumidor %d, NO HAY OBJETOS, NO PUEDO CONSUMIR\n",numcons);
			fflush(stdout);
		}
	}
}

void op_signal(int sem, int n){
  struct sembuf sop;
  sop.sem_num = n;
  sop.sem_op = 1;
  sop.sem_flg = 0;
  semop(sem, &sop,1);
}

void op_wait(int sem, int n){
  struct sembuf sop;
  sop.sem_num = n;
  sop.sem_op = -1;
  sop.sem_flg = 0;
  semop(sem, &sop,1);
}

Prodcons.sh
#!/bin/bash
./inicioprodcons 123 3 ##inicioprodcons KEY NumeroSems
./productor 123 1 2 & ##productor KEY NumeroSems delay
./productor 123 2 1 & ##productor KEY NumeroSems delay
./consumidor 123 1 2 & ##consumidor KEY NumeroSems delay
./consumidor 123 2 2 & ##consumidor KEY NumeroSems delay
./consumidor 123 3 2 & ##consumidor KEY NumeroSems delay
